--
-- Project: Rolling
-- Version: 1.35
-- User: ChisleLP
-- Date: 26.10.2018
-- Time: 01:18
-- Do not edit below, if you don't know what you do.
--

--[[
// 0 = None
// 1 = Warrior          PLATE
// 2 = Paladin          PLATE
// 3 = Hunter           CHAIN
// 4 = Rouge            LEATHER
// 5 = Priest           CLOTH
// 6 = DeathKinght      PLATE
// 7 = Shaman           CHAIN
// 8 = Mage             CLOTH
// 9 = Warlock          CLOTH
// 10 = Monk            LEATHER
// 11 = Druid           LEATHER
// 12 = Demon Hunter    LEATHER
--]]

ClassSpecify = {}
ClassSpecify[0] = "none"
ClassSpecify[1] = "Plate"
ClassSpecify[2] = "Plate"
ClassSpecify[3] = "Chain"
ClassSpecify[4] = "Leather"
ClassSpecify[5] = "Cloth"
ClassSpecify[6] = "Plate"
ClassSpecify[7] = "Chain"
ClassSpecify[8] = "Cloth"
ClassSpecify[9] = "Cloth"
ClassSpecify[10] = "Leather"
ClassSpecify[11] = "Leather"
ClassSpecify[12] = "Leather"

local _, _, pc = UnitClass("player")
PlayerClass = ClassSpecify[pc]

local f = CreateFrame("Frame", "Rolling_Frame", UIParent, "BasicFrameTemplateWithInset")
f:SetSize(300, 230)
f:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", 0, 350)
f:SetMovable(true)
f:EnableMouse(true)
f:SetUserPlaced(true)
f:SetScript("OnMouseDown", f.StartMoving)
f:SetScript("OnMouseUp", f.StopMovingOrSizing)

f.ennd = CreateFrame("Button", nil, f, "GameMenuButtonTemplate")
f.ennd:SetPoint("Right", f, "TOP", -30, -200)
f.ennd:SetSize(100, 20)
f.ennd:SetText("End")
f.ennd:RegisterForClicks("AnyUp")

f.cancel = CreateFrame("Button", nil, f, "GameMenuButtonTemplate")
f.cancel:SetPoint("LEFT", f, "TOP", 30, -200)
f.cancel:SetSize(100, 20)
f.cancel:SetText("Cancel")
f.cancel:RegisterForClicks("AnyUp")

f.title = f:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
f.title:SetPoint("LEFT", f.TitleBg, "LEFT", 5, 0)
f.title:SetText("Rolling")

f.recommend = f:CreateFontString(nil, "ARTWORK")
f.recommend:SetFont("Fonts\\ARIALN.ttf", 18, "OUTLINE")
f.recommend:SetPoint("TOPLEFT", 10, -30)
f.recommend:SetJustifyH("LEFT")

f.recommended = f:CreateFontString(nil, "ARTWORK")
f.recommended:SetFont("Fonts\\ARIALN.ttf", 18, "OUTLINE")
f.recommended:SetPoint("TOPLEFT", 10, -50)
f.recommended:SetJustifyH("LEFT")

f.text = f:CreateFontString(nil, "ARTWORK")
f.text:SetFont("Fonts\\ARIALN.ttf", 18, "OUTLINE")
f.text:SetPoint("TOPLEFT", 10, -80)
f.text:SetJustifyH("LEFT")

f.txt1 = f:CreateFontString(nil, "ARTWORK")
f.txt1:SetFont("Fonts\\ARIALN.ttf", 14, "OUTLINE")
f.txt1:SetPoint("TOPLEFT", 10, -99)
f.txt1:SetJustifyH("LEFT")

f.txt2 = f:CreateFontString(nil, "ARTWORK")
f.txt2:SetFont("Fonts\\ARIALN.ttf", 14, "OUTLINE")
f.txt2:SetPoint("TOPLEFT", 10, -135)
f.txt2:SetJustifyH("LEFT")

f.txt3 = f:CreateFontString(nil, "ARTWORK")
f.txt3:SetFont("Fonts\\ARIALN.ttf", 14, "OUTLINE")
f.txt3:SetPoint("TOPLEFT", 10, -170)
f.txt3:SetJustifyH("LEFT")
--f.text:SetText("|cffffff00[1] |cff0099ffPLAYER 1|cffffff00 Rolled a |cff0099ff90\n\n|cff669999[2] |cff0099ffPLAYER 2 |cff669999 Rolled a |cff0099ff89\n\n|cff663300[3] |cff0099ffPLAYER 3|cff663300 Rolled a |cff0099ff88")

f:Hide()


local function finish()
    if rolling == true then
        if playerroll[1] then
            table.sort(playerroll, function(a,b) return a>b end)
            SendChatMessage(playerdata[playerroll[1]].." won "..item.."  by Rolling with number "..playerroll[1]..". Addons by 'Rolling Manager'", "RAID")
            clear()
            f:Hide()
        else
            clear()
            print("|cff00ccff[Rolling] |cFFFF0000No one Rolled it.")
        end
    else
        print("|cff00ccff[Rolling] |cFFFF0000You didn't started a roll.")
    end
end

local function cancel()
    if rolling == true then
        --SendChatMessage("Sorry. it was maybe a mistake. I cancel the roll! Addons by 'Rolling Manager'", target)
        clear()
        f:Hide()
    else
        print("|cff00ccff[Rolling] |cFFFF0000You didn't started a roll.")
    end
end

function clear()
    f.txt1:SetText("")
    f.txt2:SetText("")
    f.txt3:SetText("")
    f.recommend:SetText("")
    f.recommended:SetText("")
    loop = nil
    rolling = false
    playerdatac = {}
    playerdata = {}
    playerdatan = {}
    playerdatai = {}
    playerdatain = {}
    playerroll = {}
    classcheck = nil
    item = nil
end

clear()
local _rollMessageTailRegex = RANDOM_ROLL_RESULT:gsub("%(", "%%("):gsub("%)", "%%)"):gsub("%%d", "(%%d+)"):gsub("%%%d+%$d", "(%%d+)"):gsub("%%s", ""):gsub("%%%d+%$s", "").. "$"



f.ennd:SetScript("OnClick", function()
    finish()
end)

f.cancel:SetScript("OnClick", function()
    cancel()
end)

f:RegisterEvent("CHAT_MSG_SYSTEM")
f:SetScript("OnEvent",function(_,_,...)
    if rolling == true then
        local msg, arg2 = ...
        if msg then
            local roll, min, max = msg:match(_rollMessageTailRegex)
            roll = tonumber(roll)
            min = tonumber(min)
            max = tonumber(max)
            if roll then
                local name = msg:gsub("%s*" .. _rollMessageTailRegex, "")
                if playerdatan[name] then
                    print("|cFFFF0000"..name.. " tried to rolling again. (But it doesn'T count, it count his first one)")
                elseif min == 1 or min == 0 and max == 100 then
                    local _, _, pc = UnitClass(name)
                    playerdatac[name] = ClassSpecify[pc]
                    local ilvl = GetAverageItemLevel(name)
                    local ilvln = floor(ilvl + 0.5)
                    playerdata[roll] = name
                    playerdatan[name] = roll
                    playerdatain[ilvln] = name
                    table.insert(playerdatai, ilvln)
                    table.sort(playerdatai, function(a,b) return a>b end)
                    table.insert(playerroll, roll)
                    table.sort(playerroll, function(a,b) return a>b end)
                    message = nil
                    if playerroll[2] then
                        f.recommend:SetText("Recommend Player:")
                        if classcheck ~= true then
                            loop = #playerdatai
                            while loop > 0 do
                                if PlayerClass == playerdatac[playerdatain[playerdatai[loop]]] then
                                    f.recommended:SetText(playerdatain[playerdatai[loop]])
                                    loop = 0
                                else
                                    loop = loop - 1
                                end
                            end
                        else
                            print(playerdatain[playerdatai[#playerdatai]])
                            f.recommended:SetText(playerdatain[playerdatai[#playerdatai]])
                        end
                    end
                    if classcheck ~= true then
                        if playerroll[1] ~= nil and playerdatac[playerdata[playerroll[1]]] ~= PlayerClass then
                            f.txt1:SetText("|cFFFF0000Not specify Class item.|r")
                        elseif playerroll[1] ~= nil then
                            f.txt1:SetText("")
                        end
                        if playerroll[2] ~= nil and playerdatac[playerdata[playerroll[2]]] ~= PlayerClass then
                            f.txt2:SetText("|cFFFF0000Not specify Class item.|r")
                        elseif playerroll[2] ~= nil then
                            f.txt2:SetText("")
                        end
                        if playerroll[3] ~= nil and playerdatac[playerdata[playerroll[3]]] ~= PlayerClass then
                            f.txt3:SetText("|cFFFF0000Not specify Class item.|r")
                        elseif playerroll[3] ~= nil then
                            f.txt3:SetText("")
                        end
                    end
                    if playerroll[3] then
                        message = "|cffffff00[1] |cff0099ff"..playerdata[playerroll[1]].."|cffffff00 Rolled a |cff0099ff"..playerroll[1].."\n\n|cff669999[2] |cff0099ff"..playerdata[playerroll[2]].." |cff669999 Rolled a |cff0099ff"..playerroll[2].."\n\n|cff663300[3] |cff0099ff"..playerdata[playerroll[3]].."|cff663300 Rolled a |cff0099ff"..playerroll[3]
                    elseif playerroll[2] then
                        message = "|cffffff00[1] |cff0099ff"..playerdata[playerroll[1]].."|cffffff00 Rolled a |cff0099ff"..playerroll[1].."\n\n|cff669999[2] |cff0099ff"..playerdata[playerroll[2]].." |cff669999 Rolled a |cff0099ff"..playerroll[2].."\n\n|cff663300[3] -"
                    elseif playerroll[1] then

                        message = "|cffffff00[1] |cff0099ff"..playerdata[playerroll[1]].."|cffffff00 Rolled a |cff0099ff"..playerroll[1].."\n\n|cff669999[2] -\n\n|cff663300[3] -"
                    end
                    if message then
                        f.text:SetText(message)
                        f:Show()
                    end
                elseif min ~= 1 and max ~= 100 then
                    print("|cFFFF0000"..name.. " tried to cheat. Min: ("..min..") Max: ("..max..")")
                elseif min ~= 1 then
                    print("|cFFFF0000"..name.. " tried to cheat. Min: ("..min..")")
                elseif max ~= 100 then
                    print("|cFFFF0000"..name.. " tried to cheat. Max: ("..max..")")
                end
            end
        end
    end
end)

SLASH_ROLLED1 = "/rr"
SlashCmdList["ROLLED"] = function(msg)
    local arg, arg1 = strsplit(" ", msg, 2)
    if arg ~= nil then
        if arg == "roll" then
            if arg1 ~= nil then
                if rolling == true then
                    print("|cff00ccff[Rolling] |cFFF4F442Restart session.")
                end
                local itemm, _, _, _, _, _, _, _, ItemLoc = GetItemInfo(arg1)
                if itemm then
                    if IsInGroup(0) then
                        clear()
                        if ItemLoc == "INVTYPE_FINGER" or ItemLoc == "INVTYPE_TRINKET" or ItemLoc == "INVTYPE_CLOAK" then
                            classcheck = true
                        end
                        rolling = true
                        item = arg1
                        print("|cff00ccff[Rolling] |cFF00FF00Rolling started!")
                        SendChatMessage("Roll "..arg1.."!", "RAID")
                    else
                        print("|cFFFF0000You can't start a roll without a Party or Raid.")
                    end
                else
                    print("|cff00ccff[Rolling] |cFFFF0000Invaild argument, Item not linked. '/rr roll [Link]'")
                end
            else
                print("|cff00ccff[Rolling] |cFFFF0000Invaild argument, Item not linked. '/rr roll [Link]'")
            end
        elseif arg == "finish" or arg == "end" then
            finish()
        elseif arg == "cancel" then
            cancel()
        end
    end
end


